if not RGM or not RGM.Build then return end

local Gsub, Lower, Match, String, Upper = string.gsub, string.lower, string.match, string.format, string.upper
local E, G, I, S, X, O = RGM, RGM_Global, RGM.Interface[1], RGM.Interface[2], RGM_Export
local Context, Frame = UI.CreateContext, UI.CreateFrame
local Insert, Remove = table.insert, table.remove
local Integer, Sort = math.floor, table.sort
local Inspect, Number = Inspect, tonumber
local Next, Pairs = next, pairs
local T, F = true, false

---- Addon Start

local User, D = Inspect.Unit.Detail("player"), {}

if not X then
	RGM_Export = {}
	X = RGM_Export
end

---- Session Manager

I.MGR = Frame("Frame", "Session Manager", I.Main)

I.MGRA1 = Frame("RiftButton", "SMA1", I.MGR)
I.MGRA2 = Frame("RiftButton", "SMA2", I.MGR)
I.MGRR1 = Frame("RiftButton", "SMR1", I.MGR)
I.MGRR2 = Frame("RiftButton", "SMR2", I.MGR)
I.MGRBG = Frame("Texture", "SMBG", I.MGR)

I.MGRB1 = Frame("Text", "SMB1", I.MGR)
I.MGRB2 = Frame("Text", "SMB2", I.MGR)
I.MGRB3 = Frame("Text", "SMB3", I.MGR)
I.MGRB4 = Frame("Text", "SMB4", I.MGR)
I.MGRB5 = Frame("Text", "SMB5", I.MGR)
I.MGRB6 = Frame("Text", "SMB6", I.MGR)

I.MGRT1 = Frame("Text", "SMT1", I.MGR)
I.MGRT2 = Frame("Text", "SMT2", I.MGR)
I.MGRT3 = Frame("Text", "SMT3", I.MGR)
I.MGRT4 = Frame("Text", "SMT4", I.MGR)
I.MGRT5 = Frame("Text", "SMT5", I.MGR)
I.MGRT6 = Frame("Text", "SMT6", I.MGR)

I.MGR:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
I.MGR:SetBackgroundColor(0.0, 0.0, 0.0, 0.8)
I.MGR:SetHeight(620)
I.MGR:SetWidth(760)
I.MGR:SetLayer(14)

I.MGRBG:SetPoint("CENTER", I.MGR, "CENTER", 0, 0)
I.MGRBG:SetTexture("RGM", "TBGM.png")
I.MGRBG:SetAlpha(0.08)
I.MGRBG:SetHeight(610)
I.MGRBG:SetWidth(750)
I.MGRBG:SetLayer(16)

I.MGRB1:SetPoint("CENTER", I.MGR, "CENTER", -182, -262)
I.MGRB1:SetBackgroundColor(0.0, 0.0, 0.0, 0.6)
I.MGRB1:SetHeight(44)
I.MGRB1:SetWidth(344)
I.MGRB1:SetLayer(18)

I.MGRB2:SetPoint("CENTER", I.MGR, "CENTER", 182, -262)
I.MGRB2:SetBackgroundColor(0.0, 0.0, 0.0, 0.6)
I.MGRB2:SetHeight(44)
I.MGRB2:SetWidth(344)
I.MGRB2:SetLayer(18)

I.MGRB3:SetPoint("CENTER", I.MGR, "CENTER", -182, -10)
I.MGRB3:SetBackgroundColor(0.0, 0.0, 0.0, 0.6)
I.MGRB3:SetHeight(414)
I.MGRB3:SetWidth(344)
I.MGRB3:SetLayer(18)

I.MGRB4:SetPoint("CENTER", I.MGR, "CENTER", 182, -10)
I.MGRB4:SetBackgroundColor(0.0, 0.0, 0.0, 0.6)
I.MGRB4:SetHeight(414)
I.MGRB4:SetWidth(344)
I.MGRB4:SetLayer(18)

I.MGRB5:SetPoint("CENTER", I.MGR, "CENTER", -182, 234)
I.MGRB5:SetBackgroundColor(0.0, 0.0, 0.0, 0.6)
I.MGRB5:SetHeight(28)
I.MGRB5:SetWidth(344)
I.MGRB5:SetLayer(18)

I.MGRB6:SetPoint("CENTER", I.MGR, "CENTER", 182, 234)
I.MGRB6:SetBackgroundColor(0.0, 0.0, 0.0, 0.6)
I.MGRB6:SetHeight(28)
I.MGRB6:SetWidth(344)
I.MGRB6:SetLayer(18)

I.MGRT1:SetPoint("CENTER", I.MGRB1, "CENTER", 0, 0)
I.MGRT1:SetText("Current Sessions")
I.MGRT1:SetFontSize(20)
I.MGRT1:SetLayer(20)

I.MGRT2:SetPoint("CENTER", I.MGRB2, "CENTER", 0, 0)
I.MGRT2:SetText("Exported Sessions")
I.MGRT2:SetFontSize(20)
I.MGRT2:SetLayer(20)

I.MGRT3:SetPoint("TOPLEFT", I.MGRB3, "TOPLEFT", 8, 6)
I.MGRT3:SetFontSize(14)
I.MGRT3:SetHeight(402)
I.MGRT3:SetWidth(324)
I.MGRT3:SetLayer(20)

I.MGRT4:SetPoint("TOPLEFT", I.MGRB4, "TOPLEFT", 8, 6)
I.MGRT4:SetFontSize(14)
I.MGRT4:SetHeight(402)
I.MGRT4:SetWidth(324)
I.MGRT4:SetLayer(20)

I.MGRT5:SetPoint("CENTER", I.MGRB5, "CENTER", 0, 0)
I.MGRT5:SetFontSize(14)
I.MGRT5:SetLayer(20)

I.MGRT6:SetPoint("CENTER", I.MGRB6, "CENTER", 0, 0)
I.MGRT6:SetFontSize(14)
I.MGRT6:SetLayer(20)

I.MGRA1:SetPoint("CENTER", I.MGR, "CENTER", -260, 278)
I.MGRA1:SetText("Add")
I.MGRA1:SetHeight(32)
I.MGRA1:SetWidth(120)
I.MGRA1:SetLayer(18)

I.MGRA2:SetPoint("CENTER", I.MGR, "CENTER", 106, 278)
I.MGRA2:SetText("Add")
I.MGRA2:SetHeight(32)
I.MGRA2:SetWidth(120)
I.MGRA2:SetLayer(18)

I.MGRR1:SetPoint("CENTER", I.MGR, "CENTER", -106, 278)
I.MGRR1:SetText("Remove")
I.MGRR1:SetHeight(32)
I.MGRR1:SetWidth(120)
I.MGRR1:SetLayer(18)

I.MGRR2:SetPoint("CENTER", I.MGR, "CENTER", 260, 278)
I.MGRR2:SetText("Remove")
I.MGRR2:SetHeight(32)
I.MGRR2:SetWidth(120)
I.MGRR2:SetLayer(18)

I.MGR:SetVisible(F)

function I.MGR.Event.RightClick()
	I.MGR.Toggle()
end

function I.MGRT3.Event.LeftClick()
	I.Temp.Current = I.Temp.Current + (I.Temp.CMax and I.Temp.CMax - 20 or 0)
	I.Temp.CS = Integer(I.Temp.Current)
	I.MGR.Select("Current")
end

function I.MGRT3.Event.RightClick()
	I.MGR.Select("C5")
end

function I.MGRT3.Event.MouseMove()
	I.Select("Current", I.MGRT3:GetTop())
end

function I.MGRT3.Event.WheelBack()
	if (I.Temp.CMax or 20) >= #E.Sessions then return end

	I.Temp.CMax = (I.Temp.CMax or 20) + 1
	I.Temp.CMin = (I.Temp.CMin or 1) + 1

	I.MGR.Sessions(0)
end

function I.MGRT3.Event.WheelForward()
	if I.Temp.CMin == 1 then return end

	I.Temp.CMax = (I.Temp.CMax or 21) - 1
	I.Temp.CMin = (I.Temp.CMin or 2) - 1

	I.MGR.Sessions(0)
end

function I.MGRT4.Event.LeftClick()
	I.Temp.Export = I.Temp.Export + (I.Temp.EMax and I.Temp.EMax - 20 or 0)
	I.Temp.ES = Integer(I.Temp.Export)
	I.MGR.Select("Export")
end

function I.MGRT4.Event.RightClick()
	I.MGR.Select("C6")
end

function I.MGRT4.Event.MouseMove()
	I.Select("Export", I.MGRT4:GetTop())
end

function I.MGRT4.Event.WheelBack()
	if (I.Temp.EMax or 20) >= #RGM_Export then return end

	I.Temp.EMax = (I.Temp.EMax or 20) + 1
	I.Temp.EMin = (I.Temp.EMin or 1) + 1

	I.MGR.Sessions(0)
end

function I.MGRT4.Event.WheelForward()
	if I.Temp.EMin == 1 then return end

	I.Temp.EMax = (I.Temp.EMax or 21) - 1
	I.Temp.EMin = (I.Temp.EMin or 2) - 1

	I.MGR.Sessions(0)
end

function I.MGRT5.Event.LeftClick()
	I.MGR.Select("C5")
end

function I.MGRT5.Event.RightClick()
	if S then S.Temp.Index = I.Temp.CS or S.Temp.Index end
	I.Temp.Index = I.Temp.CS or I.Temp.Index
	I.Clear(S and S.Clear())
	I.MGR.Select("C5")
	I.Session(S)
end

function I.MGRT6.Event.LeftClick()
	I.MGR.Select("C6")
end

function I.MGRT6.Event.RightClick()
	if I.Temp.ES then print("You must first import the session to view it") end
end

function I.MGRA1.Event.LeftClick()
	local Run = I.Temp.CS and Insert(RGM_Export, I.Temp.CS and E.Sessions[I.Temp.CS])

	I.MGR.Sessions(I.MGR.Select("C5") or 0)
end

function I.MGRA2.Event.LeftClick()
	local Run = I.Temp.ES and Insert(E.Sessions, I.Temp.ES and RGM_Export[I.Temp.ES])

	I.MGR.Sessions(I.Clear(S and S.Clear()) or I.MGR.Select("C6") or I.Session(S) or 0)
end

function I.MGRR1.Event.LeftClick()
	if I.Temp.CMax == #E.Sessions and I.Temp.CMin > 1 then
		I.Temp.CMax = I.Temp.CMax - 1
		I.Temp.CMin = I.Temp.CMin - 1
	end

	local Run = I.Temp.CS and Remove(E.Sessions, E.Sessions[I.Temp.CS] and I.Temp.CS)
	local Ran = (I.MGR.Select("C5") or I.Clear() or S and S.Clear() or I.Session(S))
end

function I.MGRR2.Event.LeftClick()
	if I.Temp.EMax == #RGM_Export and I.Temp.EMin > 1 then
		I.Temp.EMax = I.Temp.EMax - 1
		I.Temp.EMin = I.Temp.EMin - 1
	end

	local Run = I.Temp.ES and Remove(RGM_Export, RGM_Export[I.Temp.ES] and I.Temp.ES)
	local Ran = I.MGR.Sessions(I.MGR.Select("C6") or 0)
end

function I.MGR.Select(Input)
	local Current, Export, Name = E.Sessions[I.Temp.CS], RGM_Export[I.Temp.ES], F

	if Input == "Current" then
		if not Current or Name then return end
		
		for k,v in Pairs(Current) do
			if v.Relation == "hostile" and not Name then
				Name = v.Name
			end
		end
		
		I.MGRT5:SetText(String("[%0s][%0s] %0s\n", I.Temp.CS, I.Duration(Current), Name or "Unknown"))
	end

	if Input == "Export" then
		if not Export or Name then return end
		
		for k,v in Pairs(Export) do
			if v.Relation == "hostile" and not Name then
				Name = v.Name
			end
		end
		
		I.MGRT6:SetText(String("[%0s][%0s] %0s\n", I.Temp.ES, I.Duration(Export), Name or "Unknown"))
	end

	if Input == "C5" then
		I.Temp.CS = I.MGRT5:SetText("")
	end

	if Input == "C6" then
		I.Temp.ES = I.MGRT6:SetText("")
	end
end

function I.MGR.Sessions(Input)
	if not Input then return end

	local A = {["Max"] = I.Temp.CMax or (#E.Sessions < 20 and #E.Sessions) or 20, ["Min"] = I.Temp.CMin or 1}
	local B = {["Max"] = I.Temp.EMax or (#RGM_Export < 20 and #RGM_Export) or 20, ["Min"] = I.Temp.EMin or 1}
	local Current, Export, Name = "", "", F

	for i = A.Min, A.Max do
		if not E.Sessions[i] then break end
		
		for k,v in Pairs(E.Sessions[i]) do
			if v.Relation == "hostile" and not Name then
				Name = v.Name
			end
		end
		
		Current, Name = String("%0s[%0s][%0s] %0s\n", Current, i, I.Duration(E.Sessions[i]), Name or "Unknown"), F
	end

	for i = B.Min, B.Max do
		if not RGM_Export[i] then break end
		
		for k,v in Pairs(RGM_Export[i]) do
			if v.Relation == "hostile" and not Name then
				Name = v.Name
			end
		end
		
		Export, Name = String("%0s[%0s][%0s] %0s\n", Export, i, I.Duration(RGM_Export[i]), Name or "Unknown"), F
	end

	I.MGRT3:SetText(Current)
	I.MGRT4:SetText(Export)
end

function I.MGR.Toggle()
	I.MGR:SetVisible(not I.MGR:GetVisible())
	I.MGR.Sessions(I.MGR:GetVisible())

	if not I.MGR:GetVisible() then
		I.Temp.CS = I.MGR.Select("C5")
		I.Temp.ES = I.MGR.Select("C6")
	end
end

---- Injections

function I.Mini.Event.LeftClick()
	if G[1].MiniQuick and G[1].MiniMouse then G[1].MiniMouse = O return end

	local Complete = {MainX = 0, MainY = 0, Mode = {"ASB", "AVD", "BLK", "DMG", "DPS", "DTN", "HLG", "HPS", "HTN", "INT", "MSD", "OHG", "OKL", "OPS"}, Modes = 14, Sort = {G[1].Sort[1], G[1].Sort[2]}}
	local Player = Inspect.Unit.Detail("player")
	local Item, Update = I.Temp.Mini, F

	if Item < 2 then
		if not Update then
			E.Data, E.Extra, E.Ignore, E.Sessions, I.Data, I.Temp = {}, {}, {}, {}, {}, {Complete = I.Temp.Complete, Mode = I.Temp.Mode}
			E.Active = I.Clear()
		end
		
		if S and not Update then
			S.Data, S.Temp = {}, {Complete = S.Temp.Complete, Mode = S.Temp.Mode}
			S.Mini.Update(S.Clear())
		end
		
		if Player and Player.combat then
			E.Enter()
		end
	elseif Item < 3 then
		if E.Active and Next(E.Data) then
			Update = (I and not I.Session(not I.Clear()) and I.Mini.Update() or S and not S.Session(not S.Clear()) and S.Mini.Update())
			E.Active, E.Sessions[#E.Sessions + 1] = O, E.Clean(E.Data)
		end
	elseif Item < 4 then
		if not S and not Update then
			E.Interface[2] = {Build = {}, Data = {}, Mouse = {}, Temp = {}}
			S = (not E.Build.Interface() and E.Interface[2])
			S.Main:SetVisible(T)
		else
			S.Main:SetVisible(not S.Main:GetVisible())
		end
		
		if not S.Main:GetVisible() then
			I.MGR:SetParent(I.Main)
		end
		
		if S and D then
			S.Mini.Event.MiddleClick = D.MiddleClick
			S.Mini.Event.LeftClick = D.LeftClick
			S.Mini.Position = D.Position
			S.Mini.Change = D.Change
			S.Mini.Update = D.Update
			S.Session = D.Session
			S.Update = D.Updater
			
			D = O
		end
		
		Update = (not S.Main:GetVisible() and S.Clear() or S.Session(0))
		G[2].Show = S.Main:GetVisible()
	elseif Item < 5 then
		G[1].Side = (G[1].Side == "hostile" and "friendly" or "hostile")
		I.Session(I.Clear())
	elseif Item < 6 then
		I.Temp.Complete = ((not I.Temp.Complete or O) and Complete)
		I.Temp.Complete = (I.Main.Reset() or I.Temp.Complete)
		
		if not I.Temp.Complete then
			I.Main:SetPoint(G[1].Point[1], UIParent, "CENTER", G[1].MainX, G[1].MainY)
		else
			I.Main:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
		end
		
		Update = (I.Events:SetVisible(F) or I.Build.Modes() or I.Session())
	elseif Item < 7 then
		local Session = I.Session(0, 0)
		
		if Session and Session.Log and Next(Session.Log) then
			I.Log:SetVisible(not I.Log:GetVisible())
			I.Log.Update(Session.Log)
		else
			I.Log:SetVisible(F)
		end
		
		I.Temp.Log, I.Temp.Units = O, O
	elseif Item > 10 then
		I.MGR.Toggle()
	else
		I.Mini.Change("Down")
		Update = T
	end

	if Item < 3 then
		I.MGR.Select("C5")
		I.MGR.Select("C6")
		I.MGR.Sessions(0)
	end

	if not G[1].MiniQuick and (Item and Item > 0 and not Update) then
		G[1].MiniShow = not G[1].MiniShow
		
		I.Mini:SetVisible(G[1].MiniShow)
		I.Temp.Mini = O
	end
end

function I.Mini.Event.MiddleClick()
	if I.Temp.Mini > 9 and I.Temp.Mini < 10 then
		I.Latest()
	end
end

function I.Mini.Change(Input, Item)
	local Session = (E.Active and #E.Sessions + 1 or #E.Sessions)
	local Item = (Item or I.Temp.Mini > 7 and I.Temp.Mini)

	if not Item then return end

	if Item < 8 then
		if Input == "Up" then
			G[1].Modes = (G[1].Modes < 14 and G[1].Modes or 13) + 1
		else
			G[1].Modes = (G[1].Modes > 2 and G[1].Modes or 2) - 1
		end
		
		I.Session(not I.Build.Modes(I.Mini.Update()))
	elseif Item < 9 then
		if Input == "Up" then
			G[1].Slots.Value = (G[1].Slots.Value == 28 and 1 or G[1].Slots.Value == 1 and 5 or G[1].Slots.Value + 1)
		else
			G[1].Slots.Value = (G[1].Slots.Value == 1 and 28 or G[1].Slots.Value > 5 and G[1].Slots.Value - 1 or 1)
		end
		
		G[1].Slots.Stop = G[1].Slots.Value
		I.Session()
	elseif Item < 10 then
		if Input == "Up" then
			I.Temp.Index = (I.Temp.Index or Session) + 1
		else
			I.Temp.Index = (I.Temp.Index or Session) - 1
		end
		
		if I.Temp.Index and (I.Temp.Index > Session or I.Temp.Index == Session) then
			I.Temp.Index = O
		end
		
		if not E.Active and Session < 2 and I.Temp.Index and I.Temp.Index < 1 then
			I.Temp.Index = O
		end
		
		if I.Temp.Index and I.Temp.Index < 1 then
			I.Temp.Index = 001
		end
		
		if not E.Sessions[I.Temp.Index] then
			I.Temp.Index = O
		end
		
		I.Session(I.Clear())
	end
end

function I.Mini.Position()
	local X = I.Main:GetLeft() - 902
	local Y = I.Main:GetTop() - 466

	if G[1].MiniQuick then
		I.Mini:SetPoint("CENTER", UIParent, "CENTER", G[1].MiniX, G[1].MiniY)
	else
		I.Mini:SetPoint("CENTER", UIParent, "CENTER", X, Y)
	end
end

function I.Mini.Update()
	local Session = (I.Temp.Index or E.Active and #E.Sessions + 1 or #E.Sessions)
	local Slots = (G[1].Slots.Value < 2 and "Self" or G[1].Slots.Value)
	local Text = F

	if G[1].Side and G[1].Side == "friendly" then
		Text = String(" %0s \n %0s \n %0s \n %0s \n %0s \n %0s", "Delete Data", "New Session", "Second Panel", "Show Enemies", "All Data Modes", "Unit Death Log")
		Text = String("%0s \n %0s %0s \n %0s %0s \n %0s %0s \n %0s", Text, "Data Modes:", G[1].Modes, "Unit Slots:", Slots, "Session:", Session, "Manager")
	else
		Text = String(" %0s \n %0s \n %0s \n %0s \n %0s \n %0s", "Delete Data", "New Session", "Second Panel", "Show Allies", "All Data Modes", "Unit Death Log")
		Text = String("%0s \n %0s %0s \n %0s %0s \n %0s %0s \n %0s", Text, "Data Modes:", G[1].Modes, "Unit Slots:", Slots, "Session:", Session, "Manager")
	end

	if Text then
		I.MiniTX:SetText(Text)
	end

	I.Mini:SetHeight(I.MiniTX:GetHeight() + 10)
	I.MiniBG:SetHeight(I.Mini:GetHeight() - 8)
	I.Mini:SetWidth(I.MiniTX:GetWidth() + 8)
	I.MiniBG:SetWidth(I.Mini:GetWidth() - 8)
end

function I.Select(Frame, Top)
	local Mouse = (Frame and Inspect.Mouse())

	if Frame == "Meter" or Frame == "Units" then
		I.Temp[Frame] = (G[1].Slots.Start > 1 and G[1].Slots.Start - 1 or 0) + Integer((Mouse.y + 18.00) - Top) / 20
	end

	if Frame == "Events" or Frame == "Mini" then
		I.Temp[Frame] = Integer((Mouse.y + 14.00) - Top) / 20
	end

	if Frame == "Current" or Frame == "Export" then
		I.Temp[Frame] = Integer((Mouse.y + 16.00) - Top) / 20
	end
end

function I.Session(Update, Return, Skip)
	local Session = (E.Active and E.Data or E.Sessions[#E.Sessions])

	if I.Temp.Index and I.Temp.Index <= #E.Sessions then
		Session = E.Sessions[I.Temp.Index]
	else
		I.Temp.Index = O
	end

	if Return then
		return (Skip and I.Update(Session, 0) or Session)
	end

	if Update then
		if Update == E.Interface[2] then
			E.Interface[2].Session(0)
		end
	else
		G[1].Slots.Stop = G[1].Slots.Value
		G[1].Slots.Start = 1
		I.Mini.Update()
	end

	if I.MGR:GetVisible() then
		I.MGR.Sessions(0)
		I.Mini.Update()
	end

	I.Update(Session)
end

function I.Update(Input, Skip)
	if not Input or not Input.Time or I.Mouse.LeftM then return end

	local Detail, Time = Inspect.Unit.Detail, Input.Time.Duration
	local G, Text, Total = G[1], {}, {"Total"}

	if Time and Time - 0.2 < 0 then
		Time = 0.88
	end

	if #I.Data > 0 then
		I.Data = {}
	end

	for k,v in Pairs(Input) do
		local Unit = (v.Name and not v.Relation and Detail(k))
		local Run = Match(v.Name or "", "%a+")
		local Name = (v.Name or "")
		
		if Run and not v.Relation then
			v.Relation = (Unit and Unit.relation or Unit and (Unit.alliance == User.alliance and "friendly" or Unit.role and "friendly") or "hostile")
		end
		
		if not E.Active and v.Relation == "friendly" and v.Name and not v.Player then
			Run, v.Name = O, O
		end
		
		if v.Relation == "friendly" and v.Name and not v.Player then
			Run = O
		end
		
		if G.Slots.Value == 1 then
			if G.Side == "friendly" and not (k == E.User) then
				Run = (v.Name and F)
			else
				G.Slots.Stop = 5
			end
		end
		
		if G.Short and Name and not v.Player then
			Name = (Match(Name, "%a+%s%a+%s%a+") or Name)
		end
		
		if G.Short and Name and v.Player then
			Name = Match(Name, "%a+")
		end
		
		if G.Side == v.Relation and Run then
			I.Data[#I.Data + 1] = {Detail = {["Display"] = Name, ["Name"] = v.Name, ["Unit"] = k}, ["Given"] = {}, ["Taken"] = {}}
			
			for k,v in Pairs(v.Abilities) do
				for k,v in Pairs(v.Given or {}) do
					I.Data[#I.Data].Given[k] = I.Count(I.Data[#I.Data].Given[k], k, v)
				end
				
				for k,v in Pairs(v.Taken or {}) do
					I.Data[#I.Data].Taken[k] = I.Count(I.Data[#I.Data].Taken[k], k, v)
				end
			end
		end
	end

	if #I.Data > 0 then
		Sort(I.Data, I.Sort)
	end

	for k,v in Pairs(I.Data) do
		local Coding = (Input[v.Detail.Unit] and Input[v.Detail.Unit].Calling)
		local Valid = (k >= G.Slots.Start and k <= G.Slots.Stop)
		local G = (I.Temp.Complete or G)
		
		if Coding then
			Coding = (Coding == "cleric" and '<font color="#40C412">' or Coding == "mage" and '<font color="#A86BFF">' or Coding == "rogue" and '<font color="#E0E028">' or Coding == "warrior" and '<font color="#FC3232">' or Coding == "primalist" and '<font color="#33D4FF">' or '<font color="#E68A00">')
		else
			Coding = (not Coding and '<font color="#E68A00">')
		end
		
		if Coding and v.Detail.Unit == E.User then
			Coding = '<font color="#488DFF">'
		end
		
		for i = 1, G.Modes do
			local Mode = I.Search(i)
			local Output = F
			
			if Mode then
				Output = (v[Mode.Type] and v[Mode.Type][Mode.Event] or 0)
			end
			
			if Output and Match(G.Mode[i], "%aPS") then
				Output = Output / Time
			end
			
			if Valid then
				Text[i + 1] = String("%0s%0s%5s</font>\n", (Text[i + 1] or ""), Coding, I.Short(Output or 0))
			end
			
			Total[i + 1] = (Total[i + 1] or 0) + (Output or 0)
		end
		
		if Valid then
			Text[1] = String("%0s%0s%0s: %0s</font>\n", (Text[1] or ""), Coding, k, v.Detail.Display)
		end
	end

	if #Text > 0 and not Skip then
		local G = (I.Temp.Complete or G)
		
		for i = 1, G.Modes do
			if Text[i + 1] and I["Meter" .. i] then
				I["Meter" .. i]:SetText(String("%0s%5s", Text[i + 1], I.Short(Total[i + 1])), T)
			end
		end
		
		I.Units:SetText(String("%0s%0s: %0s", Text[1], #I.Data, Total[1]), T)
		I.Main:SetHeight(I.Units:GetHeight() + 28.00 - 0.88)
		I.MainBG:SetHeight(I.Main:GetHeight() - 8)
		I.Time:SetText(I.Duration(Input))
	end
end

---- Overrides

function D.LeftClick()
	if G[2].MiniQuick and G[2].MiniMouse then G[2].MiniMouse = O return end

	local Complete = {MainX = 0, MainY = 0, Mode = {"ASB", "AVD", "BLK", "DMG", "DPS", "DTN", "HLG", "HPS", "HTN", "INT", "MSD", "OHG", "OKL", "OPS"}, Modes = 14, Sort = {G[2].Sort[1], G[2].Sort[2]}}
	local Player = Inspect.Unit.Detail("player")
	local Item, Update = S.Temp.Mini, F

	if Item < 2 then
		if not Update then
			E.Data, E.Extra, E.Ignore, E.Sessions, S.Data, S.Temp = {}, {}, {}, {}, {}, {Complete = S.Temp.Complete, Mode = S.Temp.Mode}
			E.Active = S.Clear()
		end
		
		if I and not Update then
			I.Data, I.Temp = {}, {Complete = I.Temp.Complete, Mode = I.Temp.Mode}
			I.Mini.Update(I.Clear())
		end
		
		if Player and Player.combat then
			E.Enter()
		end
	elseif Item < 3 then
		if E.Active and Next(E.Data) then
			Update = (S and not S.Session(not S.Clear()) and S.Mini.Update() or I and not I.Session(not I.Clear()) and I.Mini.Update())
			E.Active, E.Sessions[#E.Sessions + 1] = O, E.Clean(E.Data)
		end
	elseif Item < 4 then
		if not I and not Update then
			E.Interface[2] = {Build = {}, Data = {}, Mouse = {}, Temp = {}}
			I = (not E.Build.Interface() and E.Interface[2])
			I.Main:SetVisible(T)
		else
			I.Main:SetVisible(not I.Main:GetVisible())
		end
		
		if not I.Main:GetVisible() then
			I.MGR:SetParent(S.Main)
		end
		
		Update = (not I.Main:GetVisible() and I.Clear() or I.Session(0))
		G[1].Show = I.Main:GetVisible()
	elseif Item < 5 then
		G[2].Side = (G[2].Side == "hostile" and "friendly" or "hostile")
		S.Session(S.Clear())
	elseif Item < 6 then
		S.Temp.Complete = ((not S.Temp.Complete or O) and Complete)
		S.Temp.Complete = (S.Main.Reset() or S.Temp.Complete)
		
		if not S.Temp.Complete then
			S.Main:SetPoint(G[2].Point[1], UIParent, "CENTER", G[2].MainX, G[2].MainY)
		else
			S.Main:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
		end
		
		Update = (S.Events:SetVisible(F) or S.Build.Modes() or S.Session())
	elseif Item < 7 then
		local Session = S.Session(0, 0)
		
		if Session and Session.Log and Next(Session.Log) then
			S.Log:SetVisible(not S.Log:GetVisible())
			S.Log.Update(Session.Log)
		else
			S.Log:SetVisible(F)
		end
		
		S.Temp.Log, S.Temp.Units = O, O
	elseif Item > 10 then
		I.MGR.Toggle()
	else
		S.Mini.Change("Down")
		Update = T
	end

	if Item < 3 then
		I.MGR.Select("C5")
		I.MGR.Select("C6")
		I.MGR.Sessions(0)
	end

	if not G[2].MiniQuick and (Item and Item > 0 and not Update) then
		G[2].MiniShow = not G[2].MiniShow
		
		S.Mini:SetVisible(G[2].MiniShow)
		S.Temp.Mini = O
	end
end

function D.MiddleClick()
	if S.Temp.Mini > 9 and S.Temp.Mini < 10 then
		S.Latest()
	end
end

function D.Change(Input, Item)
	local Session = (E.Active and #E.Sessions + 1 or #E.Sessions)
	local Item = (Item or S.Temp.Mini > 7 and S.Temp.Mini)

	if not Item then return end

	if Item < 8 then
		if Input == "Up" then
			G[2].Modes = (G[2].Modes < 14 and G[2].Modes or 13) + 1
		else
			G[2].Modes = (G[2].Modes > 2 and G[2].Modes or 2) - 1
		end
		
		S.Session(not S.Build.Modes(S.Mini.Update()))
	elseif Item < 9 then
		if Input == "Up" then
			G[2].Slots.Value = (G[2].Slots.Value == 28 and 1 or G[2].Slots.Value == 1 and 5 or G[2].Slots.Value + 1)
		else
			G[2].Slots.Value = (G[2].Slots.Value == 1 and 28 or G[2].Slots.Value > 5 and G[2].Slots.Value - 1 or 1)
		end
		
		G[2].Slots.Stop = G[2].Slots.Value
		S.Session()
	elseif Item < 10 then
		if Input == "Up" then
			S.Temp.Index = (S.Temp.Index or Session) + 1
		else
			S.Temp.Index = (S.Temp.Index or Session) - 1
		end
		
		if S.Temp.Index and (S.Temp.Index > Session or S.Temp.Index == Session) then
			S.Temp.Index = O
		end
		
		if not E.Active and Session < 2 and S.Temp.Index and S.Temp.Index < 1 then
			S.Temp.Index = O
		end
		
		if S.Temp.Index and S.Temp.Index < 1 then
			S.Temp.Index = 001
		end
		
		if not E.Sessions[S.Temp.Index] then
			S.Temp.Index = O
		end
		
		S.Session(S.Clear())
	end
end

function D.Position()
	local X = S.Main:GetLeft() - 902
	local Y = S.Main:GetTop() - 466

	if G[2].MiniQuick then
		S.Mini:SetPoint("CENTER", UIParent, "CENTER", G[2].MiniX, G[2].MiniY)
	else
		S.Mini:SetPoint("CENTER", UIParent, "CENTER", X, Y)
	end
end

function D.Update()
	local Session = (S.Temp.Index or E.Active and #E.Sessions + 1 or #E.Sessions)
	local Slots = (G[2].Slots.Value < 2 and "Self" or G[2].Slots.Value)
	local Text = F

	if G[2].Side and G[2].Side == "friendly" then
		Text = String(" %0s \n %0s \n %0s \n %0s \n %0s \n %0s", "Delete Data", "New Session", "Primary Panel", "Show Enemies", "All Data Modes", "Unit Death Log")
		Text = String("%0s \n %0s %0s \n %0s %0s \n %0s %0s \n %0s", Text, "Data Modes:", G[2].Modes, "Unit Slots:", Slots, "Session:", Session, "Manager")
	else
		Text = String(" %0s \n %0s \n %0s \n %0s \n %0s \n %0s", "Delete Data", "New Session", "Primary Panel", "Show Allies", "All Data Modes", "Unit Death Log")
		Text = String("%0s \n %0s %0s \n %0s %0s \n %0s %0s \n %0s", Text, "Data Modes:", G[2].Modes, "Unit Slots:", Slots, "Session:", Session, "Manager")
	end

	if Text then
		S.MiniTX:SetText(Text)
	end

	S.Mini:SetHeight(S.MiniTX:GetHeight() + 10)
	S.MiniBG:SetHeight(S.Mini:GetHeight() - 8)
	S.Mini:SetWidth(S.MiniTX:GetWidth() + 8)
	S.MiniBG:SetWidth(S.Mini:GetWidth() - 8)
end

function D.Session(Update, Return, Skip)
	local Session = (E.Active and E.Data or E.Sessions[#E.Sessions])

	if S.Temp.Index and S.Temp.Index <= #E.Sessions then
		Session = E.Sessions[S.Temp.Index]
	else
		S.Temp.Index = O
	end

	if Return then
		return (Skip and S.Update(Session, 0) or Session)
	end

	if Update then
		if Update == E.Interface[1] then
			E.Interface[1].Session(0)
		end
	else
		G[2].Slots.Stop = G[2].Slots.Value
		G[2].Slots.Start = 1
		S.Mini.Update()
	end

	if I.MGR:GetVisible() then
		I.MGR.Sessions(0)
		S.Mini.Update()
	end

	S.Update(Session)
end

function D.Updater(Input, Skip)
	if not Input or not Input.Time or S.Mouse.LeftM then return end

	local Detail, Time = Inspect.Unit.Detail, Input.Time.Duration
	local G, Text, Total = G[2], {}, {"Total"}

	if Time and Time - 0.2 < 0 then
		Time = 0.88
	end

	if #S.Data > 0 then
		S.Data = {}
	end

	for k,v in Pairs(Input) do
		local Unit = (v.Name and not v.Relation and Detail(k))
		local Run = Match(v.Name or "", "%a+")
		local Name = (v.Name or "")
		
		if Run and not v.Relation then
			v.Relation = (Unit and Unit.relation or Unit and (Unit.alliance == User.alliance and "friendly" or Unit.role and "friendly") or "hostile")
		end
		
		if not E.Active and v.Relation == "friendly" and v.Name and not v.Player then
			Run, v.Name = O, O
		end
		
		if v.Relation == "friendly" and v.Name and not v.Player then
			Run = O
		end
		
		if G.Slots.Value == 1 then
			if G.Side == "friendly" and not (k == E.User) then
				Run = (v.Name and F)
			else
				G.Slots.Stop = 5
			end
		end
		
		if G.Short and Name and not v.Player then
			Name = (Match(Name, "%a+%s%a+%s%a+") or Name)
		end
		
		if G.Short and Name and v.Player then
			Name = Match(Name, "%a+")
		end
		
		if G.Side == v.Relation and Run then
			S.Data[#S.Data + 1] = {Detail = {["Display"] = Name, ["Name"] = v.Name, ["Unit"] = k}, ["Given"] = {}, ["Taken"] = {}}
			
			for k,v in Pairs(v.Abilities) do
				for k,v in Pairs(v.Given or {}) do
					S.Data[#S.Data].Given[k] = S.Count(S.Data[#S.Data].Given[k], k, v)
				end
				
				for k,v in Pairs(v.Taken or {}) do
					S.Data[#S.Data].Taken[k] = S.Count(S.Data[#S.Data].Taken[k], k, v)
				end
			end
		end
	end

	if #S.Data > 0 then
		Sort(S.Data, S.Sort)
	end

	for k,v in Pairs(S.Data) do
		local Coding = (Input[v.Detail.Unit] and Input[v.Detail.Unit].Calling)
		local Valid = (k >= G.Slots.Start and k <= G.Slots.Stop)
		local G = (S.Temp.Complete or G)
		
		if Coding then
			Coding = (Coding == "cleric" and '<font color="#40C412">' or Coding == "mage" and '<font color="#A86BFF">' or Coding == "rogue" and '<font color="#E0E028">' or Coding == "warrior" and '<font color="#FC3232">' or Coding == "primalist" and '<font color="#33D4FF">' or '<font color="#E68A00">')
		else
			Coding = (not Coding and '<font color="#E68A00">')
		end
		
		if Coding and v.Detail.Unit == E.User then
			Coding = '<font color="#488DFF">'
		end
		
		for i = 1, G.Modes do
			local Mode = S.Search(i)
			local Output = F
			
			if Mode then
				Output = (v[Mode.Type] and v[Mode.Type][Mode.Event] or 0)
			end
			
			if Output and Match(G.Mode[i], "%aPS") then
				Output = Output / Time
			end
			
			if Valid then
				Text[i + 1] = String("%0s%0s%5s</font>\n", (Text[i + 1] or ""), Coding, S.Short(Output or 0))
			end
			
			Total[i + 1] = (Total[i + 1] or 0) + (Output or 0)
		end
		
		if Valid then
			Text[1] = String("%0s%0s%0s: %0s</font>\n", (Text[1] or ""), Coding, k, v.Detail.Display)
		end
	end

	if #Text > 0 and not Skip then
		local G = (S.Temp.Complete or G)
		
		for i = 1, G.Modes do
			if Text[i + 1] and S["Meter" .. i] then
				S["Meter" .. i]:SetText(String("%0s%5s", Text[i + 1], S.Short(Total[i + 1])), T)
			end
		end
		
		S.Units:SetText(String("%0s%0s: %0s", Text[1], #S.Data, Total[1]), T)
		S.Main:SetHeight(S.Units:GetHeight() + 28.00 - 0.88)
		S.MainBG:SetHeight(S.Main:GetHeight() - 8)
		S.Time:SetText(S.Duration(Input))
	end
end

---- Addon End

if S then
	I.MGR:SetParent(S.Main)

	S.Mini.Event.MiddleClick = D.MiddleClick
	S.Mini.Event.LeftClick = D.LeftClick
	S.Mini.Position = D.Position
	S.Mini.Change = D.Change
	S.Mini.Update = D.Update
	S.Session = D.Session
	S.Update = D.Updater

	D = O
end